//+------------------------------------------------------------------+
//|                                                   TakeProfit.mq4 |
//|                               Copyright  2006, Taylor Stockwell |
//|                                               stockwet@yahoo.com |
//|                                                    Version: 2.3  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Taylor Stockwell"
#property link      "stockwet@yahoo.com"


/*
Updates:

   11/2/2006:: Fixed bug that caused the sl var to be set to 1 when a pending
               order was > than the First_Stop_Target value.
*/

//=============== VARS external
extern int First_Target = 120;
extern int Target_Increment = 20;
extern double Close_Lots = 0.03;
extern bool Move_Stops = true;
extern int First_Stop_Target = 100;
extern int First_Stop = 0;
extern int Second_Stop_Target = 50;
extern int Second_Stop = 10;

extern int Third_Stop_Target = 320;
extern int Third_Stop = 300;
extern int Fourth_Stop_Target = 420;
extern int Fourth_Stop = 400;
extern int Fifth_Stop_Target = 520;
extern int Fifth_Stop = 500;

extern bool Use_Max_Loss = true;
extern int Max_Loss = 500;
extern int Magic_Number=0;

//=============== VARS internal
int nextTP;
int sl;
int range = 5;
int multiplier;
// OrderType == 1 is OP_SELL




//=============== FUNCTION init
int init()
  {
   sl=0;
   nextTP = First_Target;
   getMaxLoss();
  }
//== end function


//=============== FUNCTION deinit
int deinit()
  {
//----
   sl=0;
   nextTP = First_Target;
//----
   return(0);
  }
//== end function

//========== FUNCTION Start
int start()
  {
//----
   getOpenOrders();
   getSpread();
   //Comment(sl);
//----
   return(0);
  }
//== end function

//========== FUNCTION getPipValue
int getPipValue(double ord,int dir)
{
   int val;
   RefreshRates();
   if(dir == 1) val=((ord - Ask)/Point);
   else val=(Bid - ord)/Point;
   return(val);   
}
//== end function

int getSpread()
{
   int spread=MarketInfo(Symbol(),MODE_SPREAD);
   return(spread);
}


int getMaxLoss()
{
   int calcMaxLoss;
   if(Symbol()=="USDJPY" || Symbol()=="EURJPY") multiplier = 100;
   else multiplier = 10000;
   //if(Max_Loss == 0) calcMaxLoss = 2+15+getSpread();
   //if(Max_Loss == 0) calcMaxLoss = 30;
   //else calcMaxLoss = Max_Loss;
   calcMaxLoss = Max_Loss;
   return(calcMaxLoss);
}
//========== FUNCTION getOpenOrders
void getOpenOrders()
{
   int nsl, nsd;
   string mngMagic;
   int totalorders = OrdersTotal();
   for(int j=0; j<totalorders;j++)
     {  
         OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
         if((OrderType() == OP_BUY || OrderType() == OP_SELL) && OrderSymbol() == Symbol()&&(Magic_Number==0 || Magic_Number == OrderMagicNumber()))
         {
            sl=0;
            int val=getPipValue(OrderOpenPrice(),OrderType());
            if(Use_Max_Loss && Max_Loss > 0) killTrade(val,OrderTicket());
            if(Move_Stops) checkStops(val,OrderTicket());
            takeProfit(val,OrderTicket());            
         }
         
         if(Magic_Number == 0)
         mngMagic = "All "+Symbol()+" trades.";
         else
         mngMagic = "Trades with magic number = "+Magic_Number;
         
         
         if(sl==0)
            {
               nsl = First_Stop_Target;
               nsd = First_Stop;
            }
          else
            {
               nsl = Second_Stop_Target;
               nsd = Second_Stop;
            }
         RefreshRates();
         Comment("Order Open: ",OrderOpenPrice(), 
         "\nPip Count: ", val,
         "\nNext Stop Target: ",nsl,
         "\nNext Stop Differential: ", nsd,
         "\nNext TP: ", nextTP,
         "\nSL: ",sl,
         "\nMax Loss: ", getMaxLoss(),
         "\nManaging: ",mngMagic);

     }  
}

//========== FUNCTION takeProfit
void takeProfit(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {

      if(pips >= nextTP && pips < (nextTP + Target_Increment))
      {
         if(OrderType()==1)
         {
            if(OrderClose(ticket, Close_Lots, Ask, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError()); 
         } 
         else
         {
            if(OrderClose(ticket, Close_Lots, Bid, 3, YellowGreen))
            nextTP+=Target_Increment;
            else
            Print("Error closing order : ",GetLastError()); 
         }
              
      }

   }
}

//== end function
//=================================
//========== FUNCTION moveStops
void checkStops(int pips,int ticket)
{
      if(pips >= First_Stop_Target && pips < Second_Stop_Target)
      {
         moveStops(ticket, First_Stop);
      }
      else if(pips >= Second_Stop_Target && pips < Third_Stop_Target)
      {
         moveStops(ticket, Second_Stop);
      }
      else if(pips >= Third_Stop_Target && pips < Fourth_Stop_Target)
      {
         moveStops(ticket, Third_Stop);
      }
      else if(pips >= Fourth_Stop_Target && pips < Fifth_Stop_Target)
      {
         moveStops(ticket, Fourth_Stop);
      }
      else if(pips >= Fifth_Stop_Target)
      {
         moveStops(ticket, Fifth_Stop);
      }
}
//================================= 


//========== FUNCTION moveStops
/*
void checkStops(int pips,int ticket)
{
   if(sl==0 && pips < Second_Stop_Target)
   {
      if(pips >= First_Stop_Target && pips < (Second_Stop_Target))
      {
         moveStops(ticket, First_Stop);
      }
   }
   else if(sl==1 || pips >= Second_Stop_Target)
   {
      if(pips >= Second_Stop_Target)
      {
         moveStops(ticket,Second_Stop);
      }
   }
}
//== end function
*/

//========== FUNCTION moveStops
void moveStops(int ticket,int stopDiff)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      Print("moveStops called ",ticket, " ",stopDiff);
      if(OrderType()==OP_SELL) //SELL
         {
         if((OrderStopLoss()>Ask+stopDiff) || (OrderStopLoss() ==0))
            {
            OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()-stopDiff*Point, OrderTakeProfit(),0,Plum);
            sl++;
            }
         }
      if (OrderType()==OP_BUY) // BUY 
         {
         if((OrderStopLoss()<Bid-Point*stopDiff) || (OrderStopLoss()==0))
            {
            OrderModify(ticket,OrderOpenPrice(),OrderOpenPrice()+stopDiff*Point, OrderTakeProfit(),0,Plum);
            sl++;
            }
         }
   }
}

//== end function

//========== FUNCTION killTrades
void killTrade(int pips, int ticket)
{
   if(OrderSelect(ticket, SELECT_BY_TICKET)==true)
   {
      if(pips <= -1*getMaxLoss())
      {
         if(OrderType()==1) OrderClose(ticket,OrderLots(),Ask,3,Red);     
         else OrderClose(ticket,OrderLots(),Bid,3,Red); 
      }      
   }
}
//== end function